// ShowMemC.cpp : Definiert den Einstiegspunkt fr die Anwendung.
//

#include "stdafx.h"
#include "ShowMemC.h"

BOOL MsgErr(HWND hWnd, DWORD dwCode, LPCTSTR lpTitle)
{
	TCHAR szBuf[1024];
    if(FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, dwCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&szBuf[0], 1024, NULL))
	{
		MessageBox(hWnd, (LPCTSTR)&szBuf[0], lpTitle, MB_ICONERROR);
		return TRUE;
	}
	else
	{
		swprintf(szBuf, 1024, L"Error retrieving message for error code %d.", dwCode);
		MessageBox(hWnd, szBuf, lpTitle, MB_ICONERROR);
		return FALSE;
	}
}

TCHAR *FormatNumber(DWORDLONG uulNumber, TCHAR *lpBuffer)
{
	const TCHAR szUnit[] = L" KB";
	int i, cnt;
	TCHAR szBuf[20];
	TCHAR *lpBufPos;
	_i64tow(uulNumber, szBuf, 10);
	cnt = wcslen(szBuf);
	lpBufPos = lpBuffer;
	for(i = 0; i < cnt; i++)
	{
		if((i > 0) && (((cnt - i) % 3) == 0))
		{
			lpBufPos[0] = L'.';
			lpBufPos++;
		}
		lpBufPos[0] = szBuf[i];
		lpBufPos++;
	}
	wcscpy(lpBufPos, szUnit);
	return lpBuffer;
}

BOOL ShowMemPair(HWND hDlg, DWORDLONG uulTotalMem, DWORDLONG uulAvailMem, int nIdStaticUsed, int nIdStaticFree)
{
	TCHAR szBuf[25];
	FormatNumber(((uulTotalMem - uulAvailMem) / 1024), szBuf);
	SetDlgItemText(hDlg, nIdStaticUsed, szBuf);
	FormatNumber((uulAvailMem / 1024), szBuf);
	SetDlgItemText(hDlg, nIdStaticFree, szBuf);
	return TRUE;
}

BOOL ShowMem(HWND hDlg)
{
	MEMORYSTATUSEX stat;
	stat.dwLength = sizeof(stat);
	if(GlobalMemoryStatusEx(&stat))
	{
		ShowMemPair(hDlg, stat.ullTotalPageFile, stat.ullAvailPageFile, IDC_STATIC_TMU, IDC_STATIC_TMF);
		ShowMemPair(hDlg, stat.ullTotalPhys, stat.ullAvailPhys, IDC_STATIC_PMU, IDC_STATIC_PMF);
		if(IsIconic(hDlg))
		{
			TCHAR szBuf[25];
			FormatNumber(((stat.ullTotalPageFile - stat.ullAvailPageFile) / 1024), szBuf);
			SetWindowText(hDlg, szBuf);
		}
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

LRESULT CALLBACK WndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR szBuf[256];
	switch(message)
	{
	case WM_INITDIALOG:
		ShowMem(hDlg);
		SetTimer(hDlg, 54826, 1000, NULL);
		SetClassLongPtr(hDlg, GCLP_HICON, (LONG_PTR)LoadIcon((HINSTANCE)lParam, MAKEINTRESOURCE(IDI_SHOWMEMC)));
		SetClassLongPtr(hDlg, GCLP_HICONSM, NULL);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BTN_MINIMIZE:
			ShowWindow(hDlg, SW_MINIMIZE);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	case WM_TIMER:
		if(wParam == 54826)
		{
			ShowMem(hDlg);
		}
		break;
	case WM_SIZE:
		switch(wParam)
		{
		case SIZE_MINIMIZED:
			ShowMem(hDlg);
			break;
		case SIZE_RESTORED:
			SetWindowText(hDlg, L"Show Memory");
			ShowMem(hDlg);
			break;
		}
		break;
	}
	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	if(DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_MAINWIN), 0, (DLGPROC)WndProc, (LPARAM)hInstance) < 0)
	{
		MsgErr(0, GetLastError(), L"Error opening dialog");
		return -2;
	}
	else
	{
		return 0;
	}
}
